;-------------Tuner bistabil mit A6818
		list 	p=16f874
;-----------Portleitungen definieren
#define		datenausgabe	portd, 7	;output, zum a6818
#define		clok		portb, 1	;output, zum a6818
#define		strobe		portb, 0	;output, zum a6818
#define		swr1.2		portc, 0	;output fr LED
#define		swr1.5		portc, 1	;output fr LED
#define		swr1.7		portc, 2	;output fr LED
#define		swr2		portc, 3	;output fr LED
#define		swr2.5		portc, 4	;output fr LED
#define		swr3		portc, 5	;output fr LED
#define		swrgroesser3	portc, 6	;output fr LED
#define		high_z_led		portc, 7	;output fr LED: an, wenn high-low relais auf high z steht 
#define		sda		portb, 5	;sda zum eeprom
#define		scl		portb, 4	;scl zum eeprom
#define		hi_lo_1		portb, 2	;output, high_low relais schaltpin
#define		hi_lo		portb, 3	;output, high_low relais schaltpin

;------------Registerzuordnungen-------
indf		equ	0x00
cnter		equ	0x01
pc		equ	0x02
status		equ	0x03
fsr		equ	0x04
porta		equ	0x05
portb		equ	0x06
portc		equ	0x07
portd		equ	0x08
porte		equ	0x09
pclath		equ	0x0a
trisa		equ	0x85
trisb		equ	0x86
trisc		equ	0x87
trisd		equ	0x88
trise		equ	0x89
intcon		equ	0x0b
opt		equ	0x81
;----AD Wandler Register
adresl		equ	0x9e
adresh		equ	0x1e
adcon0		equ	0x1f
adcon1		equ	0x9f
;-----Timer1 Register
pir1		equ	0x0c
pie1		equ	0x8c
tmr1l		equ	0x0e
tmr1h		equ	0x0f
t1con		equ	0x10
;-----USART register
txreg		equ	0x19
txsta		equ	0x98
rcsta		equ	0x18
spbrg		equ	0x99	
;------EEPROM Register------
eeadr		equ	0x10d
eecon1		equ	0x18c
eedata		equ	0x10c
eecon2		equ	0x18d




;------------Allgemeine Register-------
	cblock	0x20
	cap		
	ind		
	capser			
	indser			
	capser_1				
	indser_1			
	count		
	cap_2		
	flow		
	z5			
	frequenz		
	z1			
	zaehl			
	uv			
	ur			
	adcount1		
	adcount2		
	loopcount		
	rest1			
	swr			
	rest			
	z2			
	swralt			
	restalt			
	zaehler			
	zaehler1			
	ccount			
	aus			
	aus1			
	mcount			
	ncount			
	zaehler8				
	captemp			
	indtemp			
	cap_o5		
	ind_o5		
	ind_2		
	z10		
	z11		
	fhigh	
	adr_high		
	eezaehler		
	cap_indtemp		
	f_test	
	adr_high1		
	adr_low1		
	inh_eeprom		
	bit	
	f_test1	
	adr_low		
	bank_hi_lo		
	adr_hi_lo		
	ausgabe	
	temp100	
	temp1000		
	andreas2		
	andreas3		
	tune_high_low		
	AARGB1	
	AARGB5	
	TEMP	
	LOOPCOUNT		
	testuv1		
	testuv2		
	testur1		
	testur2		
	swrtemp
	tune_high_low_temp
	endc
;---------------BIT equates
c		equ	0
z		equ	2
rp0		equ	5
rp1		equ	6
eepgd		equ	7
rd		equ	0
wren		equ	2
wr		equ	1	
;---------------Start Programm: Anfangsadresse-----
		org	0x000
		goto	vorne

;---------------fr den ganzen programmablauf gltige vereinbarungen-----
vorne		clrwdt			;lsche watchdogtimer
		clrf	status		;lsche status register
		bcf	status, 2
		clrf	intcon		;verbiete interrupts
		clrf	porta
		clrf	portb
		clrf	portc
		clrf	portd
		clrf	porte
		bsf	status, rp0
		movlw	b'10100111'
		movwf	opt		;prescaler 256, zaehle externe Impulse an steigender Flanke
		movlw	b'10000000'		;outputs
		movwf	trisb
		movlw	b'00000000'
		movwf	trisd
		movlw	b'00000000'
		movwf	trisc
		movwf	trise
		movlw	b'00110011'		;outputs
		movwf	trisa
		bcf	status, rp0
		clrf	captemp		;neu, 31.5.
		clrf	indtemp		;neu, 31.5.
		clrf	swralt		;neu, 31.5.
		clrf	restalt		;neu, 31.5.

			
	
		
;---------------zaehler fr high low tune schritte setzen
		
		

;vorne	
		movlw	0x00		;schalte die Relais in einen definierten Zustand
		movwf	cap
		movwf	ind
		call	ser_aus		
		call	reset_hi_lo
		bcf	tune_high_low, 0	;neu;8.4.01
		bcf	portc, 7
		bcf	portb, 6
		
		
		
		movlw	0x02		;wir tunen 1mal high z und 1mal low z
		movwf	z5
;-------------		
		clrf	cap
		clrf	ind
		call	ser_aus
		btfsc	portb, 7
		goto	trif1
		goto	trif


trif1		call	sleep_jetzt
trif		btfss	tune_high_low, 0
		goto	$+2
		goto	$+3
		bcf	portc, 7
		goto	$+2
		bsf	portc, 7
		
		call	swv		

		btfsc	status, 0
		goto	gutgut1


		movlw	b'10010000'	;nigelnagelneu
		tris	portb		;
		btfsc	scl
		goto	vornex
		goto	startx
startx		movlw	b'10000000'
		tris	portb
		goto	start1
vornex		movlw	b'10000000'
		tris	portb

;-----eeprom lesen
		call	vorne1				;wie oft beim lesen oder schreiben dieses register 
					;rotiert werden muss um dann ein bit zu setzen/lschen
		
		
;---------------------routine zum auslesen des eeproms als 
;---------------------ineinanderverschachtelte subroutinen_________
zuio		movf	adr_high, 0
		movwf	adr_high1 
		movf	adr_low, 0
		movwf	adr_low1

		call	eeprom_lesen1
		movf	inh_eeprom, 0
		movwf	cap
		incf	adr_low1, 1
		call	eeprom_lesen1
		movf	inh_eeprom, 0
		movwf	ind
		movf	bank_hi_lo, 0
		movwf	adr_high1
		movf	adr_hi_lo, 0
		movwf	adr_low1
		call	eeprom_lesen1
		incf	bit, 1				;auswertung des hi Lo tune bits
		movf	bit, 0
		movwf	zaehler
		bcf	status, 0
zuiop		rrf	inh_eeprom, 1
		decfsz	zaehler, 1
		goto	zuiop
		btfsc	status, 0
		goto	full	
		goto	clear	
full		bsf	tune_high_low, 0		;hi lo tune setzen
		call	set_hi_lo
		

		goto	full1
clear		bcf	tune_high_low, 0
		call	reset_hi_lo
		

full1		movf	bit, 0
		movwf	zaehler
zuiopu		rlf	inh_eeprom, 1	;retten von inh_eeprom
		decfsz	zaehler, 1
		goto	zuiopu		
		

		call	ser_aus
		;btfsc	portb, 7
		;goto	vorne		;sig weg
		
		call	swv

		
		btfsc	status, 0
		goto	gutgut1
		bcf	tune_high_low, 0
		call	reset_hi_lo
				

;---------------cap und ind auf low----------------------------------
start1		
		movlw	0x00		;cap auf 0
		movwf	cap
		
		movwf	ind
		call	ser_aus		;gebe cap und ind als null aus
		


;---------------teste ob ein signal vorhanden ist--------------------
start		clrf	swralt
		clrf	restalt
		clrf	captemp
		clrf	indtemp
;---------------testen ob signal anliegt (vorwrtsspannung da ist)---
sig_da		btfsc	portb, 7
		goto	vorne


;---------------swr grer 1,5, tunen, (ind grob)--------------------
messung		btfss	tune_high_low, 0
		goto	$+2
		goto	$+3
		bcf	portc, 7
		goto	$+2
		bsf	portc, 7
		
		clrf	ind
		clrf	cap
		
		call	ser_aus		

		btfsc	portb, 7
		goto	vorne
		call	swv		;neu;8.4.01
		
		btfsc	status, 0	;neu;8.4.01
		goto	gutgut0		;neu;8.4.01

		call	swrverg	
		
		movlw	0x08
		movwf	z1
		movlw	0x01
		movwf	ind
		call	ser_aus

indgrob1		call	swv		;neu;8.4.01

		btfsc	status, 0		;neu;8.4.01
		goto	gutgut0		;neu;8.4.01


		call	swrverg
		bcf	status, 0
		rlf	ind, 1
		call	ser_aus
		decfsz	z1, 1
		goto	indgrob1
		movf	indtemp, 0
		movwf	ind
		
;------

messung1		movlw	0x00
		movwf	cap
		call	ser_aus		
		call	swv		;neu;8.4.01

		btfsc	status, 0		;neu;8.4.01
		goto	gutgut0		;neu;8.4.01

		call	swrverg	
		
		movlw	0x08
		movwf	z1
		movlw	0x01
		movwf	cap
		call	ser_aus

indgrob2		call	sig_weg
		btfsc	status, 2
		goto	vorne
		call	swv		;neu;8.4.01

		btfsc	status, 0		;neu;8.4.01
		goto	gutgut0		;neu;8.4.01


		call	swrverg
		bcf	status, 0
		rlf	cap, 1
		call	ser_aus
		decfsz	z1, 1
		goto	indgrob2
		
		decfsz	z5, 1			;neu;8.4.01
		goto	high1000		;neu;8.4.01	
		goto	low1000			;neu;8.4.01
high1000		bsf	tune_high_low, 0		;neu;8.4.01
		call	set_hi_lo
		goto	messung 		;neu;8.4.01
low1000		movf	indtemp, 0		;neu;8.4.01
		movwf	ind			;neu;8.4.01
		movf	captemp, 0		;neu;8.4.01
		movwf	cap			;neu;8.4.01
		btfss	tune_high_low_temp, 0		;neu;8.4.01
		goto	barb			;neu;8.4.01
		goto	barb1			;neu;8.4.01

barb		bcf	tune_high_low, 0		;neu;8.4.01
		call	reset_hi_lo
		goto	indfein			;neu;8.4.01
barb1		bsf	tune_high_low, 0		;neu;8.4.01	
		call	set_hi_lo









indfein		movf	indtemp, 0
		movwf	ind
		movf	captemp, 0
		movwf	cap
		clrf	captemp		;neu, 31.5.
		clrf	indtemp		;neu, 31.5.
		clrf	swralt		;neu, 31.5.
		clrf	restalt		;neu, 31.5.
		bcf	status, 0
		rrf	ind, 0	
		addwf	ind, 0
		movwf	zaehler	
		movf	zaehler, 0
		xorlw	0x00
		btfss	status, 2
		goto	feintun
		goto	abc
		
feintun		incf	zaehler, 1
		bcf	status, 0
		rrf	ind, 1
		
bcd		call	ser_aus
		call	sig_weg		
		btfsc	status, 2
		goto	vorne
		
		call	swv

		btfsc	status, 0
		goto	gutgut0

		call	swrverg	

		incf	ind, 1
		decfsz	zaehler, 1
		goto	bcd
		goto	capfein
abc		incf	ind, 1
		call	ser_aus
		
		call	swv
		
		
		btfsc	status, 0
		goto	gutgut0

		call	swrverg	
capfein		movf	indtemp, 0
		movwf	ind
		movf	captemp, 0
		movwf	cap
		clrf	indtemp
		clrf	captemp

		bcf	status, 0
		rrf	cap, 0	
		addwf	cap, 0
		movwf	zaehler1	
		movf	zaehler1, 0
		xorlw	0x00
		btfss	status, 2
		goto	feintun1	
		goto	abc1
		
feintun1		incf	zaehler1, 1
		bcf	status, 0
		rrf	cap, 1
		
bcd1		call	ser_aus
		call	sig_weg
		btfsc	status, 2
		goto	vorne
		call	swv
		btfsc	status, 0
		goto	gutgut0

		call	swrverg	

		incf	cap, 1
		decfsz	zaehler1, 1
		goto	bcd1
		goto	feintun1000	;neu;8.4.01
	
abc1		incf	cap, 1
		call	ser_aus
		call	sig_weg
		btfsc	status, 2
	
		goto	vorne

		call	swv
		
		btfsc	status, 0
		goto	gutgut0
		call	swrverg		;neu;8.4.01

feintun1000		movf	captemp, 0	;neu;8.4.01
		movwf	cap		;neu;8.4.01
		movf	indtemp, 0	;neu;8.4.01
		movwf	ind		;neu;8.4.01
		call	ser_aus		;neu;8.4.01
		;call	swv1		;neu;8.4.01
		;call	swrtest1	;neu;8.4.01
		;btfsc	status, 0		;neu;8.4.01
		goto	gutgut0		;neu;8.4.01
		;goto	hi_low		;neu;8.4.01

		
		
gutgut1		bsf	portb, 6		;routine wenn wert im eeprom passt
		goto	endea			;wie oben
	 				
gutgut0		clrf 	swralt
		clrf	restalt		
		clrf	captemp
		clrf	indtemp
		movlw	0x05
		subwf	ind, 1
		subwf	cap, 1
		movlw	0x0b
		movwf	z2

feinfein2		movlw	0x0b
		movwf	z1
feinfein1		call	ser_aus
		call	sig_weg
		btfsc	status, 2
		goto	vorne
		call	swv1

		call	swrverg
		
		incf	ind, 1
		decfsz	z1, 1
		goto	feinfein1	
		
		incf	cap, 1
		
		movlw	0x0b
		subwf	ind, 1

		decfsz	z2, 1
		goto	feinfein2
			
		movf	indtemp, 0
		movwf	ind
		movf	captemp, 0
		movwf	cap
		
		call	ser_aus
		call	swv	
		btfsc	status, 0
		goto	gutgut2
		goto	hi_low

gutgut2		bsf	portb, 6		;routine wenn wert im eeprom nicht passt

		movlw	b'10010000'
		tris	portb
		btfsc	scl
		goto	routex
		goto	endeaxy
endeaxy		movlw	b'10000000'
		tris	portb
		goto	gutgut1
routex		movlw	b'10000000'
		tris	portb
		;------eeprom beschreiben

		call	route
		goto	endea1000

		
		
hi_low		call	pause150ms
		bsf	portb, 6
		call	pause150ms
		bcf	portb, 6
		btfsc	portb, 7
		goto	vorne		;neu
		goto	hi_low

endea_neu		call	sleep_jetzt
		goto	endea1000




endea		
		movlw	b'10010000'	;neu, 10.4.01
		tris	portb		;neu, 10.4.01
		btfsc	scl		;neu, 10.4.01
		goto	routex1000		;neu, 10.4.01
		goto	endea1000		;neu, 10.4.01
routex1000		movlw	b'10000000'	;neu, 10.4.01
		tris	portb		;neu, 10.4.01
		call	vorne1
		call	route		;neu, 10.4.01		



endea1000		movlw	b'10000000'	;neu, 10.4.01
		tris	portb		;neu, 10.4.01

		movlw	0x14
		movwf	z10
		clrf	z11

ende3		decfsz	z10, 1
		goto	urick
		goto	auswerdung
		bsf	portb, 6
;--------------sig da: nein:nach ende3		
urick		call	ur1
		call	uv1		 
;---------------testen ob signal anliegt (vorwrtsspannung da ist)---
		btfsc	portb, 7
		goto	endea_neu		;zero flag = 1 d.h. uv = null 
		goto 	messung5	
messung5		
		
		call	swrber
		btfss	tune_high_low, 0
		goto	$+2
		goto	$+3
		bcf	portc, 7
		goto	$+2
		bsf	portc, 7
		call	swranz
				
		call	swrtest1
		
		btfsc	status, 0
		goto	gut1
		goto	ende3
gut1		incf	z11, 1
		goto	ende3
auswerdung		movlw	0x01
		subwf	z11, 0
		btfsc	status, 0
		goto	endea1000
		goto	vorne	


;---------------SUBROUTINEN-------------------------------------
;====================================================================
;----------------Test auf swr kleiner 1,5 (swr in 2 byte: swr:highbyte, rest:lowbyte)--------------
;----swr berechnung: (uv mal 256)/ur. Ergebnis in 2byte; rest nicht bercksichtigt, da kleiner als---------
;-----auflsung des ad wandlers---------
swrtest		movlw	b'00000101'
		subwf	swr, 0
		btfsc	status, 0
		goto	swrtestab
		goto	swrtestschlecht
swrtestab		btfsc	status, 2
		goto	swrtestnext
		goto	swrtestgut
swrtestnext		movlw	0x00
		subwf	rest, 0
		btfsc	status, 0
		goto	swrtestgut
		goto	swrtestschlecht
swrtestgut		bsf	status, 0
		return
swrtestschlecht	bcf	status, 0
		return

;-----------------hysterese neu tunen ab swr 2
swrtest1		movlw	b'00000011'
		subwf	swr, 0
		btfsc	status, 0
		goto	swrtestab1
		goto	swrtestschle1
swrtestab1		btfsc	status, 2
		goto	swrtestnext1
		goto	swrtestgut1
swrtestnext1	movlw	0x00
		subwf	rest, 0
		btfsc	status, 0
		goto	swrtestgut1
		goto	swrtestschle1
swrtestgut1		bsf	status, 0
		return
swrtestschle1	bcf	status, 0
		return
		

;-----------------test auf swr kleiner 1,2------
;swrtest2		movlw	0x0c
;		subwf	swr, 0
;		return


;---------------swr vergleich (mehrstufig) bessere einstellung wird gespeichert-------------------
swrverg		movf	swralt, 0	;swralt ins w register
		subwf	swr, 0		;swr minus w register
		btfsc	status, 0	;ist carry flag gesetzt? dann spring
		goto	testzer	
		return
testzer		btfss	status, 2	;swr ist grer/gleich swralt
		goto	moveneu
		goto	testrest
testrest		movf	restalt, 0
		subwf	rest, 0
		btfsc	status, 0
		goto	moveneu			;da ist neu 18.03.2001
		return
testzer0		btfss	status, 2
		goto	moveneu
		return
;-----------
moveneu		movf	swr, 0
		movwf	swralt
		movf	rest, 0
		movwf	restalt
		movf	cap, 0
		movwf	captemp
		movf	ind, 0
		movwf	indtemp
		btfss	tune_high_low, 0	;neu;8.4.01	
		goto	tune10000	;neu;8.4.01
		goto	tune1001	;neu;8.4.01
tune10000		bcf	tune_high_low_temp, 0	;neu;8.4.01
		goto	reutrn		;neu;8.4.01
tune1001		bsf	tune_high_low_temp, 0	;neu;8.4.01	
reutrn		return


;AD Wandlung und Berechnung des SWR
;AD Wandlung fr U vor und U rck
;Erst fr U rck
ur1		bsf	status, 5
		movlw	b'00000100'
		movwf	adcon1
		bcf	status, 5

		movlw	b'01000001'
		movwf	adcon0	
		call	delay10
		call	delay10
		call	delay10
		call	delay10
		call	delay10
		bsf	adcon0, 2
		btfsc	adcon0, 2
		goto	$-1
		movf	adresh, 0
		movwf	ur
		clrf	adcon0
		clrf	adresh
		clrf	adresl
		call	delay10
		call	delay10
		return

;dann fr U vor
uv1		bsf	status, 5
		movlw	b'00000100'
		movwf	adcon1
		bcf	status, 5

		movlw	b'01001001'
		movwf	adcon0
		call	delay10
		call	delay10
		call	delay10
		call	delay10
		call	delay10
		bsf	adcon0, 2
		btfsc	adcon0, 2
		goto	$-1
		movf	adresh, 0
		movwf	uv
		clrf	adcon0
		clrf	adresh
		clrf	adresl
		call	delay10
		call 	delay10	
		return
delay10		nop	;10S Pause
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		return
;---------------SWR BERECHNUNG (swrber)-------------------------

;---------------divisionsroutine-------------------------------------
swrber		clrf	AARGB1
		movf	ur, 0		;ur ins w register
		xorlw	0x00		;0  minus w register
		btfsc	status, 2	;zero flag auf 0 (ergebnis ungleich 0) testen
		goto	dahamas		;zero flag gesetzt (ergebnis = 0)
		goto 	weiter		
dahamas		movf	uv, 0		
		movwf	swr	
		clrf	rest
		goto	z100
weiter		clrf	rest1

		MOVLW	8
          	  	MOVWF	LOOPCOUNT

LOOPU1608A      	RLF	uv, 0		;AARGB0,0
              		RLF	rest1, 1	;REMB0, 1
              		MOVF	ur, 0		;BARGB0,0
              		SUBWF	rest1, 1	;REMB0, 1
	
            		BTFSC	status, 0
               		GOTO	UOK68A          
               		ADDWF	rest1, 1	;REMB0, 1
            		BCF	status, 0
UOK68A     		RLF	uv, 1		;AARGB0, 1
		DECFSZ	LOOPCOUNT, 1
		GOTO	LOOPU1608A

		CLRF	TEMP

		MOVLW	8
		MOVWF	LOOPCOUNT

LOOPU1608B		RLF	AARGB1,0
		RLF	rest1, 1	;REMB0, 1
		RLF	TEMP, 1
		MOVF	ur, 0		;BARGB0,0
		SUBWF	rest1, 1	;REMB0, 1
		CLRF	AARGB5
		CLRW
		BTFSS	status, 0
		INCFSZ	AARGB5,0
		SUBWF	TEMP, 1
		
		BTFSC	status, 0
		GOTO	UOK68B          
		MOVF	ur, 0		;BARGB0,0
		ADDWF	rest1, 1	;REMB0, 1
		CLRF	AARGB5
		CLRW
		BTFSC	status, 0
		INCFSZ	AARGB5,0
		ADDWF	TEMP, 1

		BCF	status, 0
UOK68B		RLF	AARGB1, 1

		DECFSZ	LOOPCOUNT, 1
		GOTO	LOOPU1608B


		movf	uv, 0		;uv ins w register
		movwf	swr		;geteilter wert in swr	
		movf	AARGB1, 0	;rest1 ins w register
		movwf	rest		;rest1 in rest
		clrf	AARGB1
		clrf	rest1
z100		return
;====================================================================
;Serielle Ausgabe der Cs und Ls an den A6818
;		
ser_aus		call	ser_aus1	;setzen von L und C
		;warte bis die Relais gesetzt sind		
		movlw	0x46	;0x46pause mit ca. 15ms dauer um die relais						
		movwf	mcount		;zu setzen/abfallen zu lassen
loadn		movlw	0x46		
		movwf	ncount
decn		decfsz	ncount, 1		
		goto	decn
		decfsz	mcount, 1
		goto	loadn
;Ausschalten der Ls und Cs nach settling Zeit fr die Relais		
		movlw	0xff		;erst alle ports vom a6818
		movwf	indser		;auf high
		movwf	indser_1		;muss sein, da der a6818 sonst
		movwf	capser		;ports die auf low waren mit einem peakt "versieht"
		movwf	capser_1		;und die relais dann falsch schalten
		call	ser_aus2
		call	pause10ms
		
		movlw	0x00		;dann alle ports auf low
		movwf	indser		;peak ist jetzt so gut wie weg
		movwf	indser_1
		movwf	capser
		movwf	capser_1
		call	ser_aus2
		
		return

ser_aus1		movf	cap, 0
		movwf	capser
		movwf	capser_1
		comf	capser_1, 1
		movf	ind, 0
		movwf	indser
		movwf	indser_1
		comf	indser_1, 1
ser_aus2		bcf	status, 0	;carry null
		bcf	strobe		;strobe low
		movlw	0x08
		movwf	aus
ausga		rrf	capser, 1
		btfsc	status, 0	;carry testen
		goto	eins
		goto	null
eins		bsf	datenausgabe	;dateneingang
		goto	clock
null		bcf	datenausgabe	;dateneingang
clock		bsf	clok		;clok
		bcf	clok
		call	out_capser_1
		
		decfsz	aus, 1
		goto	ausga
;---------------induktivitt setzen----------------------------------
		bcf	status, 0	;carry null
		movlw	0x08
		movwf	aus1
ausgab		rlf	indser_1, 1
		btfsc	status, 0	;carry testen
		goto	einss
		goto	nulll
einss		bsf	datenausgabe	;dateneingang
		goto	clok1
nulll		bcf	datenausgabe	;dateneingang
clok1		bsf	clok		;clok
		bcf	clok
		call	out_indser
		decfsz	aus1, 1
		goto	ausgab
		bsf	strobe
		bcf	strobe
		bcf	datenausgabe
		return

;--------------Ausgabe der comf Register als Sibroutine einer Subroutine
out_capser_1	rrf	capser_1, 1
		btfsc	status, 0	;carry testen
		goto	einssss
		goto	nulllll
einssss		bsf	datenausgabe	;dateneingang
		goto	clok3
nulllll		bcf	datenausgabe	;dateneingang
clok3		bsf	clok		;clok
		bcf	clok
		return

out_indser		rlf	indser, 1
		btfsc	status, 0	;carry testen
		goto	einsss
		goto	nullll
einsss		bsf	datenausgabe	;dateneingang
		goto	clok2
nullll		bcf	datenausgabe	;dateneingang
clok2		bsf	clok		;clok
		bcf	clok
		return

;--------------frequenzzaehler
;---------------Frequenzmessung an porta 4 ergebnis in fhigh und flow----------------------
;---------------zaehle input impulse fr 1 millisekunde-------------------------------------

frequenzmessung	clrf	cnter		;lsche timer0
		bsf	status, 5	;gehe zu bank 1
		bsf	trisa, 5	;setze porta 4, zaehle an porta 4
		bcf	status, 5	;gehe zu bank 0
	
		movlw	.99		;-
		movwf	count		; |
onems		nop			; |
		nop			; |
		nop			; |
		nop			; |
		nop			; |
		nop			; | This constitutes a one millisec delay
		nop			; | so we count during one millisec
		decfsz	count, 1	; | One MHz is 1000 pulses per millisec
		goto	onems		; |
		nop			; |
		nop
		nop			; |
		nop			; |
		nop			; |
		nop			; |
		bsf	status, 5	; |
		bcf	trisa, 5 	;-|ende zaehlen 
		bcf	status, 5	;
		call	vorteiler	;ergebnis des zaehlens in fhigh und flow
		return
;--------------------------------------------------------------------
; vorteilerroutine, die den wert der im vorteiler gespeichert ist extrahiert 
;--------------------------------------------------------------------
vorteiler		movf	cnter, 0	;timer0 ins w register 
		movwf	fhigh		;w register in fhigh
		clrf	count		;lsche temp. zaehlregister 
cycle		bcf	porta, 5	;cycle porta 4
		bsf	porta, 5
		incf	count, 1	;erhhe temp. zaehlregister
		movf	cnter, 0	;fhigh ins w register
		subwf	fhigh, 0	;schau ob sich timer0 gendert hat
		btfsc	status, 2	;wenn null...
		goto 	cycle
		comf	count, 1	;complementiere temp. zaehlregister
		incf	count, 0
		movwf	flow
		bcf	flow, 0
		bcf	flow, 1
		bcf	flow, 2	
		bcf	flow, 3
		clrf	cnter		;lsche timer0
		retlw	0x00


;--------------eeprom schreiben
eeprom_schreib	movlw	b'10100000'
		movwf	ausgabe
		call	raus_damit
		call	eeread100
		call	ack
		btfsc	sda
		goto	stop4
		goto	weiter4
stop4		movlw	b'10000000'
		tris	portb
		call	stop
		call	pause15ms
		goto	eeprom_schreib
weiter4		bcf	scl
		movlw	b'10000000'
		tris 	portb
		bcf	sda
		movf	adr_high1, 0
		movwf	ausgabe
		call	eeread100
		call	ack
		btfsc	sda
		goto	stop4
		goto	weiter5
weiter5		bcf	scl
		movlw	b'10000000'
		tris 	portb
		bcf	sda
		movf	adr_low1, 0
		movwf	ausgabe
		call	eeread100
		call	ack
		btfsc	sda
		goto	stop4
		goto	weiter6		
weiter6		bcf	scl
		movlw	b'10000000'
		tris 	portb
		bcf	sda
		movf	cap_indtemp, 0
		movwf	ausgabe
		call	eeread100
		call	ack
		btfsc	sda
		goto	stop4		
		goto	weiter7
weiter7		bcf	scl
		movlw	b'10000000'
		tris 	portb
		bcf	sda
		call	stop
		call	pause15ms		;muss im endeffekt drinnen bleiben
		return


;--------------------eeprom lesen-------------------------
eeprom_lesen	movlw	b'10100000'
		movwf	ausgabe
		call	raus_damit
		call	eeread
		call	ack
		btfsc	sda
		goto	hups1
 		goto	hierhin1
hups1		movlw	b'10000000'	
		tris	portb
		call	stop
		call	pause15ms
		goto	eeprom_lesen

hierhin1		bcf	scl
		movlw	b'10000000'
		tris	portb
		bcf	sda
		movf	adr_high1, 0
		movwf	ausgabe
		call	eeread
		call	ack
		btfsc	sda
		goto	hups1
 		goto	hierhin2

hierhin2		bcf	scl
		movlw	b'10000000'
		tris	portb
		bcf	sda
		movf	adr_low1, 0
		movwf	ausgabe
		call	eeread
		call	ack
		btfsc	sda
		goto	hups1
 		goto	hierhin3

hierhin3		bcf	scl
		movlw	b'10000000'
		tris	portb
		bcf	sda
		movlw	b'10100001'
		movwf	ausgabe
		call	raus_damit
		call	eeread
		call	ack
		btfsc	sda
		goto	hups1
 		goto	hierhin4

hierhin4		bcf	scl
		movlw	b'10000000'
		tris	portb
		bcf	sda
		call	byteread
		call	stop
		return
;--------------start sequenz---------------
raus_damit		bsf	sda
		bsf	scl
		call	k_pause
		call	k_pause
		bcf	sda
		call	k_pause
		
		bcf	scl
		;nop
		return
;-------------ende start sequenz--------
;-------------ausgabe des ersten byte--------------
eeread		movlw	0x08
		movwf	eezaehler
		bcf	status, 0
loop1		
		btfss	ausgabe, 7
		goto	geloescht			
		bsf	sda
		call	clock100
		goto	weiter1000
geloescht		bcf	sda
		call	clock100
weiter1000		rlf	ausgabe, 1
		decfsz	eezaehler, 1
		goto	loop1


		return
clock100		bsf	scl
		call	k_pause
		
		
		
		bcf	scl
		return



;----------schreiben;-------------ausgabe des ersten byte--------------
eeread100		movlw	0x08
		movwf	eezaehler
		bcf	status, 0
loop100		
		btfss	ausgabe, 7
		goto	geloescht100			
		bsf	sda
		call	clock100
		goto	weiter100
geloescht100	bcf	sda
		call	clock100
weiter100		rlf	ausgabe, 1
		decfsz	eezaehler, 1
		goto	loop100
		return

		
;---------------ack--------------
ack		bcf	scl
		movlw	b'10100000'
		tris	portb
		bcf	sda
		bsf	scl
		return
			

;---------------byteread----------
byteread		movlw	b'10100000'
		tris	portb
		movlw	0x08
		movwf	eezaehler
rtuz		bsf	scl
		nop
		btfss	sda
		goto	bcf125
		goto	bsf125
bcf125		bcf	status, 0		
		goto	sackra
bsf125		bsf	status, 0
sackra		rlf	inh_eeprom, 1
		call	k_pause
		bcf	scl
		decfsz	eezaehler, 1
		goto	rtuz
		movlw	b'10000000'
		movwf	portb
		return
;-------------eeprom mehrfach auslesen-------
eeprom_lesen1	call	eeprom_lesen
		movf 	inh_eeprom, 0
		movwf	andreas2
		call	eeprom_lesen
		movf	inh_eeprom, 0
		movwf	andreas3
		call	eeprom_lesen
		movf	andreas2, 0
		xorwf	inh_eeprom, 0
		btfss	status, 2
		goto	eeprom_lesen1
		movf	andreas3, 0
		xorwf	inh_eeprom, 0
		btfss	status, 2
		goto	eeprom_lesen1
		return

;---------------stop--------------
stop		bsf	scl
		nop
		bsf	sda
		call	k_pause
		bcf	scl
		bcf	sda
		return
;---------------kurzpause
k_pause		nop
		return

;--------------swr berechnung als verschachtelte unterroutinen
swv		call	uv1
		movf	uv, 0
		movwf	testuv1
		bcf	testuv1, 0
		
		call	ur1
		movf	ur, 0
		movwf	testur1
		bcf	testur1, 0 
		
		call	uv1
		movf	uv, 0
		movwf	testuv2
		bcf	testuv2, 0
		
		call	ur1
		movf	ur, 0
		movwf	testur2
		bcf	testur2, 0
		

		movf	testuv1, 0
		subwf	testuv2, 0
		btfss	status, 2
		goto	swv		
		movf	testur1, 0
		subwf	testur2, 0
		btfss	status, 2
		goto	swv

		call	swrber
		call	swranz
		call	swrtest
		return
	



;---------------schlaf-modus
sleep_jetzt		btfss	portc, 7
		goto	$+2
		goto	$+5
		movlw	b'00000000'		; ausschalten portc (LED Anzeige), portc,7 vorher retten
		movwf	swrtemp
		movwf	portc
		goto	$+4	
		
		movlw	b'10000000'
		movwf	swrtemp
		clrf	portc
			
		movlw	b'00001000'
		movwf	intcon
		sleep
		nop
		clrf	intcon
		return
;---------------signal weg-------
sig_weg		call	uv1
		movf	uv, 0
		xorlw	0x00
		return

;--------------swr berechnung als verschachtelte unterroutinen
swv1		call	uv1
		call	ur1
		call	swrber
		call	swranz
		return

	
;--------------eeprom lesen---------------------


		
vorne1		call	uv1
		clrf 	status
		;bcf	status, 0
		;bcf	status, 2
		movf	uv, 0		;uv ins w register
		sublw	0x02		;w register von 0x02 abziehen
		btfsc	status, 0	;carry flag auf 0 testen
		goto	vorne1		;zero flag = 1 d.h. uv = null 
andreas1		call	frequenzmessung
		movf	fhigh, 0
		movwf	temp100
		movf	flow, 0
		movwf	temp1000
		call	frequenzmessung
		movf	temp100, 0
		xorwf	fhigh, 0
		btfss	status, 2	
		goto	andreas1
		movf	temp1000, 0
		xorwf	flow, 0
		btfss	status, 2	
		goto	andreas1


		movlw	b'00001110'	;bank fr high low tuning
		movwf	bank_hi_lo	; name dafr		
		movlw	b'11100000'	;neu
		movwf	adr_hi_lo	;neu
		movlw	b'00001101'
		movwf	adr_high
		movlw	b'01110101'
		movwf	f_test
		movf	fhigh, 0
		subwf	f_test, 0
		btfss	status, 0
		goto	vorne1			;frequenz ausserhalb des bereichs
next		movlw	b'00010000'		;neu
		subwf	adr_hi_lo, 1		;neu
		movlw	b'00001000'			
		subwf	f_test, 1
		movf	fhigh, 0
		subwf	f_test, 0
		btfss	status, 0
		goto	f_fein
next1		decf	adr_high, 1		
		movlw	b'00000101'
		subwf	f_test, 0
		btfsc	status, 2
		goto	vorne1			;frequenz ausserhalb des bereichs
		goto	next



f_fein		movlw	b'11100000'
		movwf	adr_low
		decf	adr_hi_lo, 1
		decf	adr_hi_lo, 1
nit		incf	adr_hi_lo, 1
		incf	adr_hi_lo, 1
		movlw	b'00100000'
		addwf	adr_low, 1
		incf	f_test, 1
		movf	fhigh, 0
		subwf	f_test, 0
		btfss	status, 2
		goto	nit
f_fein1		decf	adr_low, 1
		decf	adr_low, 1
		movlw	b'11110000'
		movwf	f_test1
		movlw	0xff		;neu
		movwf	bit		;neu
xzad		incf	bit, 1		;neu
		movlw	b'00010000'
		addwf	f_test1, 1
		incf	adr_low, 1
		incf	adr_low, 1
		movf	flow, 0
		subwf	f_test1, 0
		btfss	status, 2
		goto	xzad
		goto	eeprom
eeprom		movf	bit, 0
		sublw	0x07
		btfss	status, 0
		goto	qwer
		goto	qwer1
qwer		incf	adr_hi_lo, 1
		movlw	0x08		
		subwf	bit, 1		;wert in bit gibt an, an welcher stelle das hi/lo
qwer1		return			;bit im register adr_hi_lo zu finden ist.


;---------routine zum beschreiben des eeproms. 
route		movf	adr_high, 0
		movwf	adr_high1
		movf	adr_low, 0
		movwf	adr_low1
		movf	cap, 0
		movwf	cap_indtemp

		call	eeprom_schreib
		movf	adr_high, 0
		movwf	adr_high1
		movf	adr_low, 0
		movwf	adr_low1
		incf	adr_low1, 1
		movf	ind, 0
		movwf	cap_indtemp
		call	eeprom_schreib	
		decf	bit, 1
		movlw	0x00
		subwf	bit, 0
		btfss	status, 2
		goto	bit1	
		goto	bittestz
bittestz		btfss	tune_high_low, 0
		goto	bcf0
		goto	bsf0
bcf0		bcf	inh_eeprom, 0
		goto	nixt0
bsf0		bsf	inh_eeprom, 0
nixt0		goto	weitert
		
		
bit1		movlw	0x01
		subwf	bit, 0
		btfss	status, 2
		goto	bit2
		goto	bittestz1
bittestz1		btfss	tune_high_low, 0 
		goto	bcf1
		goto	bsf1
bcf1		bcf	inh_eeprom, 1
		goto	nixt1
bsf1		bsf	inh_eeprom, 1
nixt1		goto	weitert

bit2		movlw	0x02
		subwf	bit, 0
		btfss	status, 2
		goto	bit3
		goto	bittestz2
bittestz2		btfss	tune_high_low, 0
		goto	bcf2
		goto	bsf2
bcf2		bcf	inh_eeprom, 2
		goto	nixt2
bsf2		bsf	inh_eeprom, 2
nixt2		goto	weitert
bit3		movlw	0x03
		subwf	bit, 0
		btfss	status, 2
		goto	bit4
		goto	bittestz3
bittestz3		btfss	tune_high_low, 0
		goto	bcf3
		goto	bsf3
bcf3		bcf	inh_eeprom, 3
		goto	nixt3
bsf3		bsf	inh_eeprom, 3
nixt3		goto	weitert

bit4		movlw	0x04
		subwf	bit, 0
		btfss	status, 2
		goto	bit5
		goto	bittestz4
bittestz4		btfss	tune_high_low, 0
		goto	bcf4
		goto	bsf4
bcf4		bcf	inh_eeprom, 4
		goto	nixt4
bsf4		bsf	inh_eeprom, 4
nixt4		goto	weitert

bit5		movlw	0x05
		subwf	bit, 0
		btfss	status, 2
		goto	bit6
		goto	bittestz5
bittestz5		btfss	tune_high_low, 0
		goto	bcf5
		goto	bsf5
bcf5		bcf	inh_eeprom, 5
		goto	nixt5
bsf5		bsf	inh_eeprom, 5
nixt5		goto	weitert

bit6		movlw	0x06
		subwf	bit, 0
		btfss	status, 2
		goto	bit7
		goto	bittestz6
bittestz6		btfss	tune_high_low, 0
		goto	bcf6
		goto	bsf6
bcf6		bcf	inh_eeprom, 6
		goto	nixt6
bsf6		bsf	inh_eeprom, 6
nixt6		goto	weitert

bit7		movlw	0x07
		subwf	bit, 0
		btfss	status, 2
		goto	bittestz7
		goto	bittestz7
bittestz7		btfss	tune_high_low, 0
		goto	bcf7
		goto	bsf7
bcf7		bcf	inh_eeprom, 7
		goto	nixt7
bsf7		bsf	inh_eeprom, 7
nixt7		goto	weitert
weitert		movf	bank_hi_lo, 0
		movwf	adr_high1
		movf	adr_hi_lo, 0
		movwf	adr_low1
		movf	inh_eeprom, 0
		movwf	cap_indtemp
		call	eeprom_schreib	
		return	
;High/Low Z Relais setzen/reseten
set_hi_lo		bsf	portb, 3
		bcf	portb, 2
		call	pause10ms
		bcf	portb, 3
		return
		
reset_hi_lo		bsf	portb, 2
		bcf	portb, 3
		call	pause10ms
		bcf	portb, 2
		return


;-------------Reset der Relais nach dem Einschalten
;reset		bsf	hi_lo_1	;high_low relais muss noch geschaltet werden
;		bcf	hi_lo
;		movlw	0x00
;		movwf	cap
;		movwf	ind
;		call	ser_aus
;		bcf	hi_lo_1			
;		return
;Pausen
pause15ms		movlw	0xff	;0x47pause mit ca. 15ms dauer um die relais						
		movwf	mcount		;zu setzen/abfallen zu lassen
loadn2		movlw	0xff		
		movwf	ncount
decn2		decfsz	ncount, 1		
		goto	decn2
		decfsz	mcount, 1
		goto	loadn2
		return
		
pause150ms	movlw	0xff	;0x47pause mit ca. 15ms dauer um die relais						
		movwf	mcount		;zu setzen/abfallen zu lassen
loadn3		movlw	0xff		
		movwf	ncount
decn3		decfsz	ncount, 1		
		goto	decn3
		decfsz	mcount, 1
		goto	loadn3
		return

pause10ms		movlw	0x46	;0x46pause mit ca. 15ms dauer um die relais						
		movwf	mcount		;zu setzen/abfallen zu lassen
loadn4		movlw	0x46		
		movwf	ncount
decn4		decfsz	ncount, 1		
		goto	decn4
		decfsz	mcount, 1
		goto	loadn4
		return




;--------------------SWR Anzeige-------------
swranz		movlw	0x07
		subwf	swr, 0
		btfsc	status, 0
		goto	$+2
		goto	testswr15 
		btfsc	status, 2
		goto	$+2 
		goto	swrbesser13
		movlw	0x80
		subwf	rest, 0
		btfsc	status, 0
		goto	swrbesser13
		goto	testswr15 
swrbesser13	btfss	tune_high_low, 0
		goto	$+4
		movlw	b'10000001'
		movwf	portc
		return		
		movlw	b'00000001'
		movwf	portc		
		return


testswr15		movlw	0x05
		subwf	swr, 0
		btfsc	status, 0
		goto	$+2
		goto	testswr17 
		btfsc	status, 2
		goto	$+2 
		goto	swrbesser15
		movlw	0x00
		subwf	rest, 0
		btfsc	status, 0
		goto	swrbesser15
		goto	testswr17 
swrbesser15	btfss	tune_high_low, 0
		goto	$+4
		movlw	b'10000011'
		movwf	portc
		return		
		movlw	b'00000011'
		movwf	portc		
		return


testswr17		movlw	0x03
		subwf	swr, 0
		btfsc	status, 0
		goto	$+2
		goto	testswr2 
		btfsc	status, 2
		goto	$+2 
		goto	swrbesser2
		movlw	0xd9
		subwf	rest, 0
		btfsc	status, 0
		goto	swrbesser2
		goto	testswr2 
swrbesser2		btfss	tune_high_low, 0
		goto	$+4
		movlw	b'10000111'
		movwf	portc
		return		
		movlw	b'00000111'
		movwf	portc		
		return


testswr2		movlw	0x03
		subwf	swr, 0
		btfsc	status, 0
		goto	$+2
		goto	testswr25 
		btfsc	status, 2
		goto	$+2
		goto	swr20
		movlw	0x00
		subwf	rest, 0
		btfsc	status, 0
		goto	swr20
		goto	testswr25 
swr20		btfss	tune_high_low, 0
		goto	$+4
		movlw	b'10001111'
		movwf	portc
		return		
		movlw	b'00001111'
		movwf	portc		
		return



testswr25		movlw	0x02
		subwf	swr, 0
		btfsc	status, 0
		goto	$+2
		goto	testswr3 
		btfsc	status, 2
		goto	$+2 
		goto	swr25
		movlw	0xf4
		subwf	rest, 0
		btfsc	status, 0
		goto	swr25
		goto	testswr3 
swr25		btfss	tune_high_low, 0
		goto	$+4
		movlw	b'10011111'
		movwf	portc
		return		
		movlw	b'00011111'
		movwf	portc		
		return


testswr3		movlw	0x02
		subwf	swr, 0
		btfsc	status, 0
		goto	$+2
		goto	swrgroesser30	;swr kann nur noch groesser als 3 sein 
		btfsc	status, 2
		goto	$+2 
		goto	swr30
		movlw	0x00
		subwf	rest, 0
		btfsc	status, 0
		goto	swr30
		goto	swrgroesser30 
swr30		btfss	tune_high_low, 0
		goto	$+4
		movlw	b'10111111'
		movwf	portc
		return		
		movlw	b'00111111'
		movwf	portc		
		return


swrgroesser30	btfss	tune_high_low, 0
		goto	$+4
		movlw	b'11111111'
		movwf	portc
		return		
		movlw	b'01111111'
		movwf	portc		
		return
;---------------------ende swr anzeige	


			
		end	




;L und C hndisch schalten
haendisch	;	btfss	tune_high_low, 0	;im Handbetrieb auf jeden Fall Lichterspiel
	;	goto	$+2
	;	goto	$+3
	;	bcf	portc, 7
	;	goto	$+2
	;	bsf	portc, 7

	;	btfsc	automatik	;schau, ob wir wieder in den automatik Modus wollen
	;	goto	return100		;zurck in den automatik Modus 

		btfsc	schalt_hi_lo		;toggle  high_low z relais
		goto	test_I_up
		call	pause15ms		;wirklich relais umschalten?
		btfsc	schalt_hi_lo
		goto	test_I_up		;nein
		btfss	tune_high_low, 0	;ja, schalte um und warte bis der Taster wieder losgelassen wird, schau
		goto	set_relais1		;vorher wie das relais im Moment steht
		goto	reset_relais1
set_relais1		bsf	hi_lo
		bcf	hi_lo_1
		bsf	tune_high_low, 0
		bsf	portc, 7
		call	pause15ms
		bcf	hi_lo
		goto	test_schalt

reset_relais1	bsf	hi_lo_1
		bcf	hi_lo
		bcf	tune_high_low, 0
		bcf	portc, 7
		call	pause15ms
		bcf	hi_lo_1

test_schalt		btfss	schalt_hi_lo
		goto	$-1		;noch gedrckt
		call	swv1

test_I_up		btfsc	i_up
		goto	test_i_down		;i_up nicht auf low (gedrckt)	
		call	pause15ms		;warte, vielleicht hat der Taster geprellt 
		btfsc	i_up
		goto	test_i_down
		goto	i_up_schalt

test_i_down		btfsc	i_down	
		goto	test_c_up
		call	pause15ms		;warte, vielleicht hat der Taster geprellt 
		btfsc	i_down
		goto	test_c_up
		goto	i_down_schalt

test_c_up		btfsc	c_up
		goto	test_c_down
		call	pause15ms		;warte, vielleicht hat der Taster geprellt 
		btfsc	c_up
		goto	test_c_down
		goto	c_up_schalt

test_c_down	btfsc	c_down
		goto	haendisch
		call	pause15ms		;warte, vielleicht hat der Taster geprellt 
		btfsc	c_down
		goto	haendisch
		goto	c_down_schalt			
		
i_down_schalt	decf	ind, 1
		goto	haendisch1		

i_up_schalt		incf	ind, 1
		goto	haendisch1		

c_down_schalt	decf	cap, 1
		goto	haendisch1		

c_up_schalt		incf	cap, 1
		goto	haendisch1		

haendisch1		call	ser_aus
		call	pause150ms
		call	swv1
		btfsc	portb, 7	;sig da?
		call	sleep_jetzt	;nein
		goto	haendisch	;ja

return100		return
		bsf	status, rp0
		movlw	b'10010000'
		movwf 	trisb
		bcf	status, rp0
		btfss	scl
		goto	return1001
		;call	swr_test		;nur ins eeprom schreiben, wenn swr besser 2 ist, ansonsten zurck
		;call	swrvergleich		;in automatik modus ohne das eeprom zu beschreiben. eeprom nur beschreiben, wenn  
		call	frequenz		;Speicherbetrieb an ist
		call	eeprom_schreib


return1001		bsf	status, rp0
		movlw	b'10000000'
		movwf	trisb
		bcf	status, rp0
		return
			
